/* 
 * embed_tcl.c V1.0 - library routines
 * 
 * Copyright (c) 1993 University of Southern California.
 * All rights reserved.                                            
 *                                                                
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation, advertising
 * materials, and other materials related to such distribution and use
 * acknowledge that the software was developed by the University of
 * Southern California, Information Sciences Institute.  The name of the
 * University may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 J. Touch / touch@isi.edu
 10/7/93

 Provides routines to handle an embedded string array, of the form created
 by tcl2array, and create a single string that can be handed to TclInterp.

 returns a pointer to a malloc'd string - free it when done.
*/

#include <malloc.h>

#define NULL 0

char *embed_arraytostring(src,numlines,numchars)
     char *src[];
     long numlines, numchars;
{
  char *dest, *dp, *sp;

  dest = dp = malloc(numchars+numlines+1);
  while (**src != NULL) {
    sp = *(src++);
    while (*sp != NULL)
      *(dp++) = *(sp++);
    *(dp++) = '\n';
  }
  *(dp++) = NULL;
  return dest;
}




